#ifndef TM1637_H
#define	TM1637_H
//------------------------------------------------------------------------------
#include "../../assets/twoWire/twoWire.h"
#include "TM1637_prototypes.h"
//Common Anode             0,    1,    2,    3,    4,    5,    6,    7,    8,   9
const char digits[] = { 0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07, 0x7f, 0x6f };
//------------------------------------------------------------------------------
void TM1637_init(void)
{
    twoWire_init();    
}
//------------------------------------------------------------------------------
void TM1637_display(int number)
{    
    twoWire_start();
    twoWire_write(0x40);
    twoWire_ack();
    twoWire_stop();
    
    twoWire_start();
    twoWire_write(0xC0);
    twoWire_ack();
    
    TM1637_write(toString(number));
    
    twoWire_stop();
}
//------------------------------------------------------------------------------
// Valid brightness values: 0 - 8.
// 0 = display off.
void TM1637_setBrightness(char level)
{  
    twoWire_start();
    
    twoWire_write(0x87 + level);
    twoWire_ack();
    
    twoWire_stop();
}
//------------------------------------------------------------------------------
void TM1637_write(char text[])
{
    while(*text)
    {
        char i = *(text++) - '0';  //Get index 0 - 9
        twoWire_write(digits[i]);
        twoWire_ack();
    }
}
//------------------------------------------------------------------------------
char* toString(int number)
{
    char strNum[10];
    sprintf(strNum,"%04d",number);  //Format number with up to 4 leading zeroes
    
    return strNum;
}
//------------------------------------------------------------------------------
#endif	/* TM1637_H */